﻿using HarmonyLib;
using System;
using System.Reflection;
using UnityEngine;
using UnityEngine.AzureSky;

public class NoFog : Mod
{
    private Harmony instance;

    public void Start()
    {
        Debug.Log("NoFog has been loaded!");
        instance = new Harmony("fr.tekgamer.nofog");
        instance.PatchAll(Assembly.GetExecutingAssembly());
    }

    [ConsoleCommand(name: "setviewdistance", docs: "Sets the view distance.")]
    public static void viewdistance(string[] args)
    {
        if (args.Length != 1)
        {
            throw new Exception("You need to specify a view distance value with 'setviewdistance'.");
        }

        int viewdistance = 1000;
        int.TryParse(args[0], out viewdistance);
        foreach (Camera c in FindObjectsOfType<Camera>()) { c.farClipPlane = viewdistance; }
        Debug.Log("The view distance has been changed to " + viewdistance);
    }

    public void OnModUnload()
    {
        instance.UnpatchAll("fr.tekgamer.nofog");
        Debug.Log("NoFog has been unloaded!");
    }
}

[HarmonyPatch(typeof(AzureSkyController))]
[HarmonyPatch("Update")]
internal class Patch_AzureSkyController_Update
{
    public static void Prefix(AzureSkyController __instance)
    {
        __instance.fogDistance = -1f;
    }
}